package com.rootsoft.rsnotificationlistener;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.ServiceHelper;
import anywheresoftware.b4a.debug.*;

public class nlservice extends android.app.Service {
	public static class nlservice_BR extends android.content.BroadcastReceiver {

		@Override
		public void onReceive(android.content.Context context, android.content.Intent intent) {
			android.content.Intent in = new android.content.Intent(context, nlservice.class);
			if (intent != null)
				in.putExtra("b4a_internal_intent", intent);
			context.startService(in);
		}

	}
    static nlservice mostCurrent;
	public static BA processBA;
    private ServiceHelper _service;
    public static Class<?> getObject() {
		return nlservice.class;
	}
	@Override
	public void onCreate() {
        mostCurrent = this;
        if (processBA == null) {
		    processBA = new BA(this, null, null, "com.rootsoft.rsnotificationlistener", "com.rootsoft.rsnotificationlistener.nlservice");
            try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
            processBA.loadHtSubs(this.getClass());
            ServiceHelper.init();
        }
        _service = new ServiceHelper(this);
        processBA.service = this;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Service (nlservice) Create **");
        processBA.raiseEvent(null, "service_create");
    }
		@Override
	public void onStart(android.content.Intent intent, int startId) {
		handleStart(intent);
    }
    @Override
    public int onStartCommand(android.content.Intent intent, int flags, int startId) {
    	handleStart(intent);
		return android.app.Service.START_NOT_STICKY;
    }
    private void handleStart(android.content.Intent intent) {
    	BA.LogInfo("** Service (nlservice) Start **");
    	java.lang.reflect.Method startEvent = processBA.htSubs.get("service_start");
    	if (startEvent != null) {
    		if (startEvent.getParameterTypes().length > 0) {
    			anywheresoftware.b4a.objects.IntentWrapper iw = new anywheresoftware.b4a.objects.IntentWrapper();
    			if (intent != null) {
    				if (intent.hasExtra("b4a_internal_intent"))
    					iw.setObject((android.content.Intent) intent.getParcelableExtra("b4a_internal_intent"));
    				else
    					iw.setObject(intent);
    			}
    			processBA.raiseEvent(null, "service_start", iw);
    		}
    		else {
    			processBA.raiseEvent(null, "service_start");
    		}
    	}
    }
	@Override
	public android.os.IBinder onBind(android.content.Intent intent) {
		return null;
	}
	@Override
	public void onDestroy() {
        BA.LogInfo("** Service (nlservice) Destroy **");
		processBA.raiseEvent(null, "service_destroy");
        processBA.service = null;
		mostCurrent = null;
		processBA.setActivityPaused(true);
	}
public anywheresoftware.b4a.keywords.Common __c = null;
public static com.rootsoft.rsnotificationservice.RSNotificationListener _notificationlistener = null;
public com.rootsoft.rsnotificationlistener.main _main = null;
public static String  _notificationlistener_closed() throws Exception{
 //BA.debugLineNum = 41;BA.debugLine="Sub NotificationListener_Closed";
 //BA.debugLineNum = 42;BA.debugLine="Log(\"Closed\")";
anywheresoftware.b4a.keywords.Common.Log("Closed");
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _notificationlistener_initialized() throws Exception{
 //BA.debugLineNum = 36;BA.debugLine="Sub NotificationListener_Initialized";
 //BA.debugLineNum = 37;BA.debugLine="Log(\"Initialized\")";
anywheresoftware.b4a.keywords.Common.Log("Initialized");
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _notificationlistener_notificationposted(Object _statusbarnotification) throws Exception{
com.rootsoft.rsnotificationservice.RSStatusBarNotification _sbn = null;
 //BA.debugLineNum = 46;BA.debugLine="Sub NotificationListener_NotificationPosted (StatusBarNotification As Object)";
 //BA.debugLineNum = 47;BA.debugLine="Dim sbn As RSStatusBarNotification";
_sbn = new com.rootsoft.rsnotificationservice.RSStatusBarNotification();
 //BA.debugLineNum = 48;BA.debugLine="sbn = StatusBarNotification";
_sbn.setObject((android.service.notification.StatusBarNotification)(_statusbarnotification));
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _notificationlistener_notificationremoved(Object _statusbarnotification) throws Exception{
com.rootsoft.rsnotificationservice.RSStatusBarNotification _sbn = null;
 //BA.debugLineNum = 52;BA.debugLine="Sub NotificationListener_NotificationRemoved (StatusBarNotification As Object)";
 //BA.debugLineNum = 53;BA.debugLine="Dim sbn As RSStatusBarNotification";
_sbn = new com.rootsoft.rsnotificationservice.RSStatusBarNotification();
 //BA.debugLineNum = 54;BA.debugLine="sbn = StatusBarNotification";
_sbn.setObject((android.service.notification.StatusBarNotification)(_statusbarnotification));
 //BA.debugLineNum = 57;BA.debugLine="End Sub";
return "";
}
public static String  _notificationlistener_received(Object _mintent) throws Exception{
anywheresoftware.b4a.objects.IntentWrapper _intent1 = null;
 //BA.debugLineNum = 59;BA.debugLine="Sub NotificationListener_Received (mIntent As Object)";
 //BA.debugLineNum = 60;BA.debugLine="Dim intent1 As Intent";
_intent1 = new anywheresoftware.b4a.objects.IntentWrapper();
 //BA.debugLineNum = 61;BA.debugLine="intent1 = mIntent";
_intent1.setObject((android.content.Intent)(_mintent));
 //BA.debugLineNum = 63;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 5;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 14;BA.debugLine="Dim NotificationListener As RSNotificationListener";
_notificationlistener = new com.rootsoft.rsnotificationservice.RSNotificationListener();
 //BA.debugLineNum = 16;BA.debugLine="End Sub";
return "";
}
public static String  _service_create() throws Exception{
 //BA.debugLineNum = 18;BA.debugLine="Sub Service_Create";
 //BA.debugLineNum = 20;BA.debugLine="NotificationListener.Initialize(\"NotificationListener\")";
_notificationlistener.Initialize(processBA,"NotificationListener");
 //BA.debugLineNum = 21;BA.debugLine="NotificationListener.FilterAction = \"com.rootsoft.rsnotificationlistener.NOTIFICATION_LISTENER_SERVICE_EXAMPLE\"";
_notificationlistener.setFilterAction("com.rootsoft.rsnotificationlistener.NOTIFICATION_LISTENER_SERVICE_EXAMPLE");
 //BA.debugLineNum = 22;BA.debugLine="NotificationListener.StartNotificationListener";
_notificationlistener.StartNotificationListener();
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _service_destroy() throws Exception{
 //BA.debugLineNum = 30;BA.debugLine="Sub Service_Destroy";
 //BA.debugLineNum = 32;BA.debugLine="End Sub";
return "";
}
public static String  _service_start(anywheresoftware.b4a.objects.IntentWrapper _startingintent) throws Exception{
 //BA.debugLineNum = 26;BA.debugLine="Sub Service_Start (StartingIntent As Intent)";
 //BA.debugLineNum = 28;BA.debugLine="End Sub";
return "";
}
}
